#!/usr/bin/perl -T
use strict;
use warnings;
use Impedance::Model;
use Impedance::IMPCGI qw(:html :cgi);
use SemaforeFile;
use File::Copy;
use CGI qw(:standard :netscape);
use SocketClient;
use LWP::UserAgent;
use Unicode::String qw(latin1 utf8);
use RFC::RFCCGI qw (get_CGI_value_clean);
use RFC::Main qw ();

my @list = ();
my $listserver = RFC::Main::get_cv('servers','listserver');

if ($listserver)
{
    chomp $listserver;
    my $str = SocketClient::socket_client($listserver,4040,'servers');
    chomp $str if ($str);
    my @l = split(/\t/,$str) if ($str && $str !~ /ERROR/);
    foreach (@l)
    {
        if (/([\w\.\-]+)/)
        {
            push @list,$1;
        }
    }
}
my @rigs = ();
foreach (@list)
{
    my $str = SocketClient::socket_client($_,4040,'rigs');
    next if (!$str || $str =~ /error/i);
    chomp $str;
    chomp $str;
    chomp $str;
    push @rigs,split(/\s+/,$str);
}
@rigs = sort {$a <=> $b} @rigs;
unshift @rigs,'';

if (param('action') && param('action') eq 'load')
{
    &print_header("Elchemea Analytical",-onload=>'set_data()');
    my @data = ();
    my $name = '';
    my $fdata = '';
    eval 
    {
	my $rig = param('rig');
	my $test = param('test');
	my $file = param('file');
	if ($file =~ /\d+\s+(.+)/)
	{
	    $name = $1;
	    $name =~ s/\:/\-/g;
	    $name =~ s/\s+/_/g;
	}
	foreach my $item ($rig,$test,$file)
	{
	    if ($item && $item=~ /(\d+)/)
	    {
		$item = $1;
	    }
	    else
	    {
		$item = 0;
	    }
	}
	my $ua = LWP::UserAgent->new();
	$ua->timeout(60);
	my $url = 'http://'.$listserver.'/cgi-bin/celltest/ajax_interface.cgi?action=imp_file&furnace=' . $rig.'&runnr='.$test.'&filenr='.$file;
	my $request = new HTTP::Request('GET',$url);
	my $response = $ua->request($request);
	my $content = $response->content();
	my @lines = split(/\n/,$content);
	my $x = 0;
	while ($x++ < @lines)
	{
	    next unless (defined($lines[$x]) && $lines[$x] =~ /^[\s\t]*\d+[\s\t]*$/);
	    last;
	}
	while ($x++ < @lines)
	{
	    push @data,$lines[$x] if (defined($lines[$x]) && $lines[$x] =~ /\d/);
	}
    };
    my $data = join("\n",@data);
    print start_form(-name=>'sofc');
    print hidden(-name=>'data',-value=>$data,-force=>1);
    print hidden(-name=>'filedata',-value=>$fdata,-force=>1);
    print hidden(-name=>'filename',-value=>$name,-force=>1);
    print hidden(-name=>'allow_close',-value=>1,-force=>1);
    print end_form();

    print <<END;

<script language="javascript">

function set_data()
{
    opener.document.sofc.data.value = document.sofc.data.value;
    opener.document.sofc.filedata.value = document.sofc.filedata.value;
    opener.document.sofc.filename.value = document.sofc.filename.value;
    opener.document.sofc.mode.value = 'plot';
    opener.sofc_submit();
    self.close();
}

</script>

END
    
    print end_html();
exit;
}

#&print_header("Elchemea Analytical",-onBlur=>'initiateSelfClosing()');
&print_header("Elchemea Analytical");
print center(h1("Load Impedance file from RFCcontrol cluster"));
print '<center><table border=0 cellspacing=20><tr>';
print start_form(-name=>'select');
print '<th> Rig: </th><td>'; 
print popup_menu(-name=>'rig',-values=>[@rigs],-default=>'',-force=>1,-onchange=>'select_rig(this.value)');
print '</td><th> Test: </th><td>';
print popup_menu(-name=>'test',-values=>[''],-default=>'',-force=>1,-onchange=>'select_test(document.select.rig.value,this.value)');
print '</td></tr><tr><td colspan=4>';
print popup_menu(-name=>'file',-values=>[''],-default=>'',-force=>1,-class=>'textfield',-onchange=>'document.select.submit()');
print_hidden();
&action('load');
print end_form();
print '</th>';
end_top_bar();
print '</center>';

print <<END;

<script language="javascript">

var name = '';
var pass = '';
var time = ''
var cred = '&name='+name+'&pass='+pass+'&jscheck=1&time='+time;
var fserver = '$listserver'+'/cgi-bin/celltest/ajax_interface.cgi';

function select_rig(r)
{
    var query = '&action=run_list&furnace='+r+cred;
    run_ajax('http://'+fserver,query,set_test);
}

function select_test(r,t)
{
    var query = '&action=imp_list&furnace='+r+"&runnr="+t+cred;
    run_ajax('http://'+fserver,query,set_files);
}

function set_files(res)
{
    var out = res.split("\\n");
    if (out[0] != "OK")
    {
        alert(res);
        return false;
    }
    document.select.file.length = 0;
    var opt = document.createElement("option");
    opt.text = '';
    opt.value = '';
    document.select.file.options.add(opt);
    for (var x = 1; x < out.length; x++)
    {
	var opt = document.createElement("option");
	opt.text = out[x];
	opt.value = out[x];
	document.select.file.options.add(opt);
    }
}

function set_test(res)
{
    var out = res.split("\\n");
    if (out[0] != "OK")
    {
        alert(res);
        return false;
    }
    document.select.test.length = 0;
    var opt = document.createElement("option");
    opt.text = '';
    opt.value = 0;
    document.select.test.options.add(opt);
    for (var x = 1; x < out.length; x++)
    {
	var opt = document.createElement("option");
	opt.text = out[x];
	opt.value = out[x];
	document.select.test.options.add(opt);
    }
}

</script>

END

print end_html();
exit;

